package rs2gprs;

/*import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;*/

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;


public class Main extends MIDlet {

	public static final boolean DebugInfoToCOM = false; //_DEBUG
	
	ATCommand		atCommand; // Создаем его здесь и раздаем разным членам.
	Tc65SerialPort	tc65SerialPort;
	Io		io;
	MenuSettings	menuSetting;
	Tc65SocketConnection socketConnection;
	/**
	 * 
	 */
	public Main() {
		try
		{
			tc65SerialPort = new Tc65SerialPort();
			serialOut("\n\rStarting rs2gprs app...\n\r" + 
					"(build 101219" +
//					", Siemens R2 SDK)\n\r" +
//					", Siemens R3 SDK)\n\r" +
					", Cinterion R1 SDK)\n\r" +
					")\n\r" );

			atCommand = new ATCommand(false);

			io = new Io();
			
			menuSetting = new MenuSettings(tc65SerialPort, atCommand, io);

			// socketConnection создадим позже
			menuSetting.start();
			
		}
		catch(Exception e) 
		{
			System.out.println(e);
			notifyDestroyed();
		}
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.out.println("destroyApp(" + arg0 + ")");

        notifyDestroyed();    

	}

	protected void pauseApp() {

	}
	/**
	 * Wrappers for debug output to serial port
	 * @param str
	 */
	void serialOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void serialOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}
	void DebugOut(String str)
	{
		if(menuSetting.DebugInfoToCOM)
			tc65SerialPort.serialOut(str.getBytes());
	}
	void DebugOut(byte[] ar)
	{
		if(menuSetting.DebugInfoToCOM)
			tc65SerialPort.serialOut(ar);
	}


	protected void startApp() throws MIDletStateChangeException {
		// Показываем, что соединение не установлено
		io.Out(0, false);
		
		// Ждем, пока меню разговаривает
		do
		{
        	try
        	{
        	Thread.sleep(1000);
        	}
        	catch(Exception e)
        	{
        		serialOut(e.toString());
        	}
		}
		while(menuSetting.isAlive());

		// Показываем, что отладочный вывод включен и будет мешать обмену 
		// данными - на это наступил человек. Если он выключен - ничего не будет видно и всё 
		// будет ОК.
 		DebugOut("Menu finished, continuing\n\r");
 		DebugOut("***************************************************\n\r" +
 				 "*             ATTENTION!!!                        *\n\r" +
 				 "* Debug output is ON. It means you will NOT get   *\n\r" +
 				 "* correct data exchange with your device.         *\n\r" +
 				 "* PLEASE TURN DEBUGGING OFF TO WORK WITH HARDWARE *\n\r" +
 				 "***************************************************\n\r" 
 				);
		
		if(menuSetting.RetCode == menuSetting.MS_EXITPROG)
		{
			DebugOut("Exiting program...\r\n");
			destroyApp(true);
		}
			
		if(menuSetting.PinWasEntered == false)
		{
			// Вводим PIN. Если ошибка - выходим.
			if(EnterPIN() == false)
			{
				DebugOut("Error entering PIN, exiting app...\n\r");
		        destroyApp(true);
			}
		}
		serialOut("\n\rSetting serial port baudrate to " + Integer.toString(menuSetting.BaudRate) + "\n\r" );
		// Настраиваем СОМ-порт на заданную скорость
		tc65SerialPort.SetBaudRate(menuSetting.BaudRate);
		
		socketConnection = new Tc65SocketConnection(tc65SerialPort);
		
		byte ar[] = new byte[2048]; // Массив для передаваемых данных
		int pos = 0; // положение в массиве

//		 Массив для данных из сокета, которые надо послать в СОМ-порт без задержки.
		// Организован как кольцевой буфер.
		byte arFromSocket[] = new byte[256];  
		int posFromSocketR = 0; 
		int posFromSocketW = 0; 
		
		boolean bExit = false;
		int IncomingDataTimer = 0; // Считаем время после последнего пришедшего байта.
		int IncomingKeepaliveTimer = 0; // Считаем время между пришедшими кипалайвами
		int KeepaliveCount = 0;
		
		// *************************************************************************
		// Почему-то здесь нельзя применять тип long, как только его применяешь, прога 
		// перестает говорить через СОМ-порт!!!
		// **************************************************************************
		
        while(bExit == false)
        {
        	// Здесь можно переинициализировать модем, иногда 
        	// это помогает для более стабильной работы
        	try{atCommand.send("ATE1&C1&D0&S0X4Q0S0=1V1\r");}
    		catch(ATCommandFailedException e){}
        	
        	try
        	{
        	Thread.sleep(5000); // Datasheet says to reconnect after 600 s delay!
        	}
        	catch(Exception e)
        	{
        		DebugOut(e.toString());
        	}
        	
        	DebugOut("*g*");
        	
      		// ставим настройки
       		SetupConnection();
	        		
    		// соединяемся
    		boolean bConnected = socketConnection.Connect();
    		// Если соединились, показываем большую букву
    		if(bConnected == true)
    		{
       			io.Out(0, true);
               	DebugOut("*G*");
    		}
    		else
    		{
       			io.Out(0, false);
    			continue;
    		}
       		// гоняем данные до разъединения
   			IncomingDataTimer = millisNow(); // Считаем время после последнего пришедшего байта.
   			IncomingKeepaliveTimer = IncomingDataTimer; // Считаем время между пришедшими кипалайвами
   			KeepaliveCount = IncomingDataTimer;
   			boolean bPreviousByteWasFF = false; // Был ли предыдущий байт кипалайвом
   			
       		while(socketConnection.IsConnected())
       		{
       			boolean Stop = false;
   				pos = 0;
   				// Получаем из СОМ-порта модема и пишем в сокет
				while(tc65SerialPort.hasData() > 0)
				{
					int j = tc65SerialPort.readByte();
					if(j != -1)
					{
						byte b = (byte)(j);
						ar[pos]=b;
						pos++;

						// Если ff, передаем 2 байта.
						if(j == menuSetting.KeepaliveByte && menuSetting.UseKeepalives == true)
						{
    						ar[pos]=b;
    						pos++;
    						DebugOut("*FF*");
						}
//            					socketConnection.writeByte(b);
					}
				}
				if(pos > 0)
				{
					socketConnection.write(ar, pos);
					KeepaliveCount = millisNow();
				}
	        				
				// Шлем кипалайвы
				if(KeepaliveCount > 20000)  // 20 секунд
				{
					KeepaliveCount = millisNow();
					if(menuSetting.UseKeepalives == true)
					{
						socketConnection.writeByte((byte)menuSetting.KeepaliveByte);
						DebugOut("*K*");
					}
				}
	        				
				// Получаем из сокета и шлем в порт, если можно.  
				int len = socketConnection.hasData();
				
				if(len > 0)
				{
        			IncomingDataTimer = millisNow();
					DebugOut("*s"+Integer.toString(len)+"*");
				}

				while(len > 0)
				{
					int j = socketConnection.readByte();
					boolean bProceed = true;
					if(j<0)
						bProceed = false;
					else
						IncomingDataTimer = millisNow();

					// Разбираемся, либо пришел байт кипалайва 0xYZ, либо байт данных 0xYZ, 
					// котороый передается как 0xYZYZ, либо другой байт.
					
					if(j != menuSetting.KeepaliveByte) // Очередной байт - не ff, забываем о кипалайве
					{
						bPreviousByteWasFF = false;
						IncomingKeepaliveTimer = millisNow();
					}
					
					if(menuSetting.UseKeepalives == true && j == menuSetting.KeepaliveByte)
					{
						// Предыдущий байт был FF и пришел давно (> 5 c)?
						if(bPreviousByteWasFF == true && IncomingKeepaliveTimer > 5000)
						{
							// Возможно, пришел кипалайв либо байт FF
							bPreviousByteWasFF = true; // Это и так стоит.
							IncomingKeepaliveTimer = millisNow(); // Сбрасываем таймер
							bProceed = false;
						}	        						
						// Предыдущий байт - не FF?
						else if(bPreviousByteWasFF == false) 
						{
							// Возможно, пришел кипалайв либо байт FF
							bPreviousByteWasFF = true; // Запоминаем, что это FF
							IncomingKeepaliveTimer = millisNow(); // Сбрасываем таймер
							bProceed = false; // не посылаем
						}
						else if(bPreviousByteWasFF == true && IncomingKeepaliveTimer <= 5000)
						{
							// Вторй раз пришел байт FF - значит, это реальный байт для посылки
							bPreviousByteWasFF = false; 
							bProceed = true;
						}
						
					}
					if(bProceed == true)
					{
						// Раньше мы посылали в порт, сейчас положим в буфер и потом отправим в порт
						arFromSocket[posFromSocketW] = (byte)j;
						posFromSocketW++;
						if(posFromSocketW >= 256) posFromSocketW = 0;
					}

					// Смотрим, есть ли еще что-то в сокете. Нет - цикл прекращается.
					len = socketConnection.hasData();
				}

				// If Modbus delay not used or exceeded the value set in menu.
				if(
						(menuSetting.UseModbus == false) ||
						(menuSetting.UseModbus == true && (((millisNow())-IncomingDataTimer) > menuSetting.ModbusDelay))
						) // If no data arrived from socket for a long time
				{
					while(posFromSocketR != posFromSocketW)
					{
						byte b = arFromSocket[posFromSocketR];
						tc65SerialPort.writeByte(b);
						posFromSocketR++;
						if(posFromSocketR >= 256) posFromSocketR = 0;
						
			        	// Вместо 2 стоп-бит лучше подождем... Все равно ТС65 не поддерживает 2 стоп-бита.
						// calculate delay to send out the byte on current baudrate:
						// 8 data + startbit + 2 stopbits + 1 guard bit for the case, *1000 ms 
						int br = menuSetting.BaudRate;
						if(br == 0) br = 1;
						int delay = (12000/menuSetting.BaudRate) + 1;
						if(delay > 50) delay = 50; if(delay < 1) delay = 1;

						if(menuSetting.BaudRate < 19200)
						{
							try
				        	{
				        	Thread.sleep(delay);
				        	}
				        	catch(Exception e)
				        	{
				        		DebugOut(e.toString());
				        	}
						}
					}
				}
				
// Дисконнект по таймауту данных и кипалайвов - если из сокета ничего не пришло.
// Если идет много данных, то икпалайвы не идут (это нормально) -
// но вываливаться при этом не надо! 

    			if((millisNow()-IncomingDataTimer) > 60000) // 60 с
    			{
					DebugOut("*S("+Integer.toString(millisNow()-IncomingDataTimer)+")["+
							Integer.toString(millisNow()-IncomingKeepaliveTimer)+"]*");
    				Stop = true;
    			}
    			if(Stop == true)
    				break;
     		}
    		// дополнительно разъединяемся руками
    		socketConnection.Disconnect();
 
    		io.Out(0, false);
			DebugOut("*D*");
			
			// В даташите написано, что реконнект лучше делать не раньше, 
			// чем через 2 минуты. Может, тут воткнуть задержку?
			// TODO
        }
         
        // В принципе, сюда мы не попадем никогда.
        
		// Настраиваем СОМ-порт обратно на 115200
        serialOut("\n\rDestroying...\n\r");
        
		io.Out(0, false); // off

		destroyApp(true);
	}

	boolean EnterPIN()
	{
		boolean bOkFound = false;
		
		if(menuSetting.PINCode.length() == 0)
		{
			DebugOut("PIN empty, will not be sent.\n\r" );
			return true;
		}
		
		// Если ПИН не цифровой - это не пин (или не настроен).
		// По умолчанию его не надо ставить.
		char ar[] = menuSetting.PINCode.toCharArray();
		boolean bIsNotPin = false;
		for(int i=0; i<menuSetting.PINCode.length(); i++)
		{
			if(ar[i] < '0' || ar[i] > '9')
				bIsNotPin = true;
		}
		if(bIsNotPin == true)
		{
			DebugOut("PIN is " + menuSetting.PINCode + "(not a PIN), will not be sent.\n\r" );
			return true;
		}
		
		DebugOut("PIN=" + menuSetting.PINCode + "\r\n" );
		String s = new String("(no command has been sent)");
		try{
		s = atCommand.send("AT+CPIN=" + menuSetting.PINCode + "\r");
		}
		catch(ATCommandFailedException e)
		{
			serialOut("Exception " + e.getMessage() + "\n\r" );
		}
		DebugOut("\r\nCommand:" + s + "\n\r" );
		
		if(s.indexOf("OK") > 0)
			bOkFound = true;
		
		return bOkFound;
	}
	
	void SetupConnection()
	{
		socketConnection.SetConnType(/*bConnType*/io.CONN_TYPE_GPRS);

		socketConnection.setAPN(menuSetting.szAPN);
		socketConnection.setURL(menuSetting.szAddressToConnectTo);
		socketConnection.setPort(menuSetting.PortToConnectTo);

		socketConnection.setUsername(menuSetting.szUsername);
		socketConnection.setPassword(menuSetting.szPassword);
	}

	// Чтобы в проге не нужно было использовать глюкавый long, делаем такую функцию.
	public int millisNow()
	{
		return (int)System.currentTimeMillis();
	}
}
